function formDataToString(formID)
{
	var data = '';
	var elems = document.getElementById(formID).elements;
	for(var i=0; i<elems.length; i++)
	{
		if(i!=0)
			data += "&";
		data += elems[i].name + "=" + elems[i].value;
	}
	return data;
}

function changeInputType(elem, value) 
{
	var eData={i:elem.id, v:elem.value, t:elem.type, s:elem.size, n:elem.name},
			newElem, newType=value;

	try
	{
		newElem=document.createElement("<input type='"+newType+"' id='"+eData.i+"' name='"+eData.n+"' value='"+eData.v+"' size='"+eData.s+"'>");
	}
	catch(e)
	{
		newElem=document.createElement('input');
		newElem.name=eData.n;
		newElem.id=eData.i;
		newElem.type=newType;
		newElem.size=eData.s;
		newElem.value=eData.v;
	}

	elem.parentNode.replaceChild(newElem, elem);

	return newElem.type;
}


function SetCurrentNav(nav,navactive)
{
    var elem;
	if( document.getElementById ) // this is the way the standards work
		elem = document.getElementById( nav );
	else if( document.all ) // this is the way old msie versions work
		elem = document.all[nav];
	else if( document.layers ) // this is the way nn4 works
		elem = document.layers[nav];

	if(elem)
		elem.setAttribute("class", navactive);
	
}

//place the popup by the cursor
var cX = 0; 
var cY = 0; 
var lastPopupOffsetX = 0;
var lastPopupOffsetY = 0;
var PutWithOffset = 2;
function UpdateCursorPosition(e)
{ 
	cX = e.pageX; 
	cY = e.pageY;
}
function UpdateCursorPositionDocAll(e)
{ 
	cX = event.clientX; 
	cY = event.clientY;
}
if(document.all) 
{ 
	document.onclick = UpdateCursorPositionDocAll; 
}
else 
{ 
	document.onclick = UpdateCursorPosition; 
}
function AssignPosition(d, offsetx, offsety) 
{
	var rX = 0; 
	var rY = 0;
	if(self.pageYOffset) 
	{
		rX = self.pageXOffset;
		rY = self.pageYOffset;
	}
	else if(document.documentElement && document.documentElement.scrollTop) 
	{
		rX = document.documentElement.scrollLeft;
		rY = document.documentElement.scrollTop;
	}
	else if(document.body) 
	{
		rX = document.body.scrollLeft;
		rY = document.body.scrollTop;
	}
	

	if(document.all)
	{
		rX += cX; 
		rY += cY;

		rX -= (document.body.offsetWidth - 900)/2;
	}	
	else
	{
		rX = cX;
		rY = cY;
		
		rX -= (window.innerWidth - 900)/2;
	}

	rY -=200;

	if(offsetx)
		rX += offsetx;

	if(offsety)
		rY += offsety;

//	alert(cX + " " + cY + " " + rX + " " + rY);

	lastPopupOffsetX = rX+10;
	lastPopupOffsetY = rY+10;

	d.style.left = (lastPopupOffsetX) + "px";
	d.style.top = (lastPopupOffsetY) + "px";
}


//hide or show the specified div
function displayLayer( whichLayer , showLayer , putByCursor, offsetx, offsety)
{
    var elem, vis, field;
	if( document.getElementById ) // this is the way the standards work
	{
		elem = document.getElementById( whichLayer );
	}
	else if( document.all ) // this is the way old msie versions work
	{
		elem = document.all[whichLayer];
	}
	else if( document.layers ) // this is the way nn4 works
	{
		elem = document.layers[whichLayer];
	}
	vis = elem.style;
	// if the style.display value is blank we try to figure it out here
	if(vis.display==''&&elem.offsetWidth!=undefined&&elem.offsetHeight!=undefined)
		vis.display = (elem.offsetWidth!=0&&elem.offsetHeight!=0)?'block':'none';

	if(showLayer)
	{
		vis.display = 'block';
		if(putByCursor == 1)
		{
			AssignPosition(elem);
		}
		else if(putByCursor == PutWithOffset)
		{
			AssignPosition(elem, offsetx, offsety);
		}
	}
	else
	{
		vis.display = 'none' ;
	}
}

function showSublayer( whichLayer, putByCursor, offsetx, offsety)
{
	var x = lastPopupOffsetX;
	var y = lastPopupOffsetY;

	if(putByCursor == 1)
	{
		offsetx = 0;
		offsety = 0;
	}
	offsetx -= x;
	offsety -= y;

	displayLayer( whichLayer , 1, 2, offsetx, offsety)

	// save these for later
	lastPopupOffsetX = x;
	lastPopupOffsetY = y;
}

/***page tabbing***********************************/
var enabletabpersistence=0 //enable tab persistence via session only cookies, so selected tab is remembered?

function RefreshPage(page)
{
	var newsearch = document.location.search;
	newsearch = ChangeGetParam(newsearch, 'page',page);
	// appendTestDiv(newsearch);
	window.location.search= newsearch;
}


function EnableById(elemId,enabled)
{
	var elem = document.getElementById(elemId);
	if( elem != null )
	{
		if( enabled )
			enable( elem );
		else
			disable( elem );
	}
}

function EnableACEButtons(haveSel)
{
	// enable, disable, cut, copy, delete, and paste buttons
	// based on selection and cut buffer.
//	EnableById( 'deleteace', haveSel );
//	EnableById( 'cutace', haveSel );
//	EnableById( 'copyace', haveSel );
	EnableById( 'deleteace', 1 );
	EnableById( 'cutace', 1 );
	EnableById( 'copyace', 1 );
	EnableById( 'selectnone', 1 );
}

// very brute way of doing this function 
function FindInArray(haystack, needle)
{	
	if( haystack && needle )	
	{		
		for(i=0;i<haystack.length;i++)		
		{			
			if( haystack[i] == needle )				
				return true;		
		}	
	}	
	return false;
}

function GetParam(name)
{
	var get_string = document.location.search;
	var name_index = get_string.indexOf(name + '=');
	var end_of_value = 0;
	var value = ''
	if(name_index != -1)
	{
		var get_string = get_string.substr(name_index + name.length + 1, get_string.length - name_index);

		end_of_value = get_string.indexOf('&');
		if(end_of_value == -1 )
			end_of_value = get_string.length;
		value= get_string.substr(0,end_of_value)
	}
	return value
}

// replace get param with new value in a search string.
function ChangeGetParam(get_string, name,newValue)
{
	var name_index = get_string.indexOf(name + '=');
	var end_of_value = 0;
	var newsearch = get_string;
	var original = get_string;

	if(name_index != -1)
	{
		var get_string = get_string.substr(name_index + name.length + 1, get_string.length - name_index);

		end_of_value = get_string.indexOf('&');
		if(end_of_value == -1 )
			end_of_value = get_string.length;
		var rlen = end_of_value + name.length + 1;
		newsearch = original.substr(0,name_index);
		newsearch += name + '=' + newValue; // "page=editacl";
		newsearch += original.substr(name_index+rlen,original.length-(name_index+rlen));
	}
	else
	{
		// add it since nothing to replace
		newsearch=newsearch+'&'+name+'='+newValue;
	}
	return newsearch;
}

function setCookie(name, value)
{
    document.cookie = name+"="+value //cookie value is domain wide (path=/)
}
/**********************end of tab script************************************/

var tabcontentIDs=new Object()
function checkSaveUser(adding)
{
	if( document.update )
	{
		// make sure if name is required they enter one.
		if( document.update.mName && document.update.mName.value == "" )
		{
			alert('Please enter a name.');
			return false;
		}
		else if( document.update.mPassword && document.update.mPasswordConfirm &&
			document.update.mPassword.value != document.update.mPasswordConfirm.value )
		{
			alert('Passwords do not match.');
			return false;
		}
		else if( document.update.mPassword && document.update.mPassword.value == "" )
		{
			alert('You must enter a password.');
			return false;
		}
	}
	return true;
}

function confirmSimplify()
{
	if( !confirm("Are you sure you want to simplify the access-list? This will remove entries that are redundant or have no effect and re-arrange the list to combine like ACL terms.") )
		return false;
	return true;
}

function advDevice(dev)
{
	document.location.href="aclserver?page=advdevice&device=" + dev;
}

// validate attempts to save things
function saveCheck()
{
	if( document.update )
	{
		// make sure if name is required they enter one.
		if( document.update.mName && document.update.mName.value == "" )
		{
			alert('Please enter a name.');
			return false;
		}
	}
	return true;
}

// validate all fields are set for test page
function testPageCheck(tcp,udp)
{

	if( document.update )
	{
		// inputs are mAccess(popup), mMatchType(popup), mCustSourceAddr, mCustSourcePort,
		// mCustTargetAddr, mCustTargetPort

		if(  document.update.mCustSourceAddr.value == "" ||
			 document.update.mCustTargetAddr.value == "" )
		{
			alert('Please enter source and destination addresses.');
			return false;
		}

		if(selectedChoice(document.update.mProto, tcp) || selectedChoice(document.update.mProto, udp))
		{
			if( document.update.mCustSourcePort.value == "" ||
				document.update.mCustTargetPort.value == "" )
			{
				alert('Please enter source and destination ports.');
				return false;
			}
		}
	}
	return true;
}

function expandcontent(linkobj)
{
    var ulid=linkobj.parentNode.parentNode.id //id of UL element
    var ullist=document.getElementById(ulid).getElementsByTagName("li") //get list of LIs corresponding to the tab contents
    for (var i=0; i<ullist.length; i++)
    {
        ullist[i].className=""  //deselect all tabs
        if (typeof tabcontentIDs[ulid][i]!="undefined") //if tab content within this array index exists (exception: More tabs than there are tab contents)
            document.getElementById(tabcontentIDs[ulid][i]).style.display="none" //hide all tab contents
    }
    linkobj.parentNode.className="selected"  //highlight currently clicked on tab
    document.getElementById(linkobj.getAttribute("rel")).style.display="block" //expand corresponding tab content
    saveselectedtabcontentid(ulid, linkobj.getAttribute("rel"))
}

function expandtab(tabcontentid, tabnumber)
{ //interface for selecting a tab (plus expand corresponding content)
    var thetab=document.getElementById(tabcontentid).getElementsByTagName("a")[tabnumber]
    if (thetab.getAttribute("rel"))
        expandcontent(thetab)
}

function savetabcontentids(ulid, relattribute)
{// save ids of tab content divs
    if (typeof tabcontentIDs[ulid]=="undefined") //if this array doesn't exist yet
    tabcontentIDs[ulid]=new Array()
    tabcontentIDs[ulid][tabcontentIDs[ulid].length]=relattribute
}

function saveselectedtabcontentid(ulid, selectedtabid)
{ //set id of clicked on tab as selected tab id & enter into cookie
    if (enabletabpersistence==1) //if persistence feature turned on
    setCookie(ulid, selectedtabid)
}

function getullistlinkbyId(ulid, tabcontentid)
{ //returns a tab link based on the ID of the associated tab content
    var ullist=document.getElementById(ulid).getElementsByTagName("li")
    for (var i=0; i<ullist.length; i++)
    {
        if (ullist[i].getElementsByTagName("a")[0].getAttribute("rel")==tabcontentid)
        {
            return ullist[i].getElementsByTagName("a")[0]
            break
        }
    }
}

function initializetabcontent()
{
    for (var i=0; i<arguments.length; i++)
    { //loop through passed UL ids
        if (enabletabpersistence==0 && getCookie(arguments[i])!="") //clean up cookie if persist=off
        setCookie(arguments[i], "")
        var clickedontab=getCookie(arguments[i]) //retrieve ID of last clicked on tab from cookie, if any
        var ulobj=document.getElementById(arguments[i])
        var ulist=ulobj.getElementsByTagName("li") //array containing the LI elements within UL
        for (var x=0; x<ulist.length; x++)
        { //loop through each LI element
            var ulistlink=ulist[x].getElementsByTagName("a")[0]
            if (ulistlink.getAttribute("rel"))
            {
                savetabcontentids(arguments[i], ulistlink.getAttribute("rel")) //save id of each tab content as loop runs
                ulistlink.onclick=function()
                {
                    expandcontent(this)
                    return false
                }
                if (ulist[x].className=="selected" && clickedontab=="") //if a tab is set to be selected by default
                expandcontent(ulistlink) //auto load currenly selected tab content
            }
        } //end inner for loop
        if (clickedontab!="")
        { //if a tab has been previously clicked on per the cookie value
            var culistlink=getullistlinkbyId(arguments[i], clickedontab)
            if (typeof culistlink!="undefined") //if match found between tabcontent id and rel attribute value
                expandcontent(culistlink) //auto load currenly selected tab content
            else //else if no match found between tabcontent id and rel attribute value (cookie mis-association)
            expandcontent(ulist[0].getElementsByTagName("a")[0]) //just auto load first tab instead
        }
    } //end outer for loop
}


function getCookie(Name)
{ 
    var re=new RegExp(Name+"=[^;]+", "i"); //construct RE to search for target name/value pair
    if (document.cookie.match(re)) //if cookie found
        return document.cookie.match(re)[0].split("=")[1] //return its value
    return ""
}

function setCookie(name, value)
{
    document.cookie = name+"="+value //cookie value is domain wide (path=/)
}
/**********************end of tab script************************************/

//stop return key from submitting form
function stopRKey(myEvent) 
{ 
    var myEvent = (myEvent) ? myEvent : ((event) ? event : null); 
    var myNode = (myEvent.target) ? myEvent.target : ((myEvent.srcElement) ? myEvent.srcElement : null); 
    if ((myEvent.keyCode == 13) && (myNode.type=="text"))  
    {
        return false;
    } 
} 
//if there is a form, then set focus to first element
function focusFirst()
{

	if(document.forms[0])
	{   //set focus to mLog to allow for the initial check of edit entry page
		if(document.forms[0].mLog)
		{
			document.forms[0].mLog.focus();
//			document.forms[0].mProto.blur();
		}
		if(document.forms[0].elements[0])
	        document.forms[0].elements[0].focus();
	}

}

function loadTestDiv(text)
{
// 	alert('loadTestDiv');
	var pnode = document.getElementById( 'testdiv' );
	if( pnode )
		pnode.innerHTML = '<p>' + text + '</p>';
}

function appendTestDiv(text)
{
// 	alert('loadTestDiv');
	var pnode = document.getElementById( 'testdiv' );
	if( pnode )
		pnode.innerHTML += '<p>' + text + '</p>';
}

function loadTreeDivCB(text) 
{ 
//	alert('loadTreeDivCB');
	if( sDest )
	{
		var pnode = document.getElementById( sDest );
		if( pnode )
		{
//			pnode.innerHTML = text;
			var newdiv = document.createElement("div");
			newdiv.innerHTML = text;
			pnode.innerHTML = "";
			pnode.appendChild(newdiv);
		}
	}
}

// load a tree div dynamically
function loadTreeDiv(dest,path)
{
	// replace inner html of dest
	// with contents returned by
	// tree page
	sDest = dest;
//	alert('loadTreeDiv');
	CoAjax('aclserver',path,'loadTreeDivCB','get','0');
}

//show animation on targetpage for synchronizing
function sync()
{
	var syncimage = document.getElementById('syncImage');
	if(syncimage) {
		syncimage.src = '/images/progopt.gif';
	}

	return true;
}

function cancel()
{
	var syncimage = document.getElementById('syncImage');
	if(syncimage) {
		syncimage.src = '/images/sync.png';
	}
}

function sync2(id)
{
	src = '/images/progopt.gif';
}

//set fields for ICMP type and code
function checkICMPMes()
{
	var str = document.update.mICMPMes.value;
	var strA = str.split(" ");
	
	document.update.mICMPType.value = strA[0];
	document.update.mICMPCode.value = strA[1];
		
}

//set fields for ICMP message
function checkICMPTypeCode()
{
	var msg = "" + document.update.mICMPType.value + " " + document.update.mICMPCode.value;
	var options = document.update.mICMPMes.getElementsByTagName("option");
	var found = false;
	for(var i=0; i<options.length; i++)
	{
		if(msg == options[i].value)
		{
			document.update.mICMPMes.value = options[i].value;
			found = true;
		}
	}	
	if(!found)
	{
	 	document.update.mICMPMes.selectedIndex = 1;
	}
}

function checkSchedule()
{
    if(document.update.mRecurring.checked)
	{
		// enable mInterval select input
		enable(document.update.mInterval);
	}
	else
	{	
		// disable mInterval input
		disable(document.update.mInterval);
	}

}

function globalauthload()
{
	
    if(document.update.auth_group[0].checked )
	{
		enable(document.update.mLoginName);
		enable(document.update.mPassword);
		enable(document.update.mEnablePass);
	}
	else
	{
		disable(document.update.mLoginName);
		disable(document.update.mPassword);
		disable(document.update.mEnablePass);
	}
}
function globalauthchange()
{
	globalauthload()
}

//logic is enable everything and disable as needed
function checkPage(except, icmpv6, icmp, tcp, udp)
{
	checkPort(icmpv6, icmp,tcp,udp);

	enableRest(icmp,tcp,udp);

    //Action = Except
    if(selectedChoice(document.update.mAccess, except))
	    setForExcept();
			
    //evaluate reflect
    if(document.update.mEvaluateReflect.checked)
        setForEvalReflect();
    
	if(document.update.mCommentOnly.checked)
		setForComment();

	// disable reflect unless permit entry, cannot reflect a deny.
      if( document.update.mAccess.value != 0 )
	  {
	  	document.update.mReflect.checked = 0;
		disable(document.update.mReflect);
	  }
		
}

function searchStart(icmpv6, icmp,tcp,udp)
{
//	checkPort(icmp,tcp,udp);
	enable(document.update.mMatchType);

	// enableMost(icmpv6, icmp,tcp,udp)
	if(document.update.mProto.value == icmp || document.update.mProto.value == icmpv6 )
		checkICMPTypeCode();
	
	checkChoice(document.update.mProto, icmp,icmpv6, 
		document.update.mICMPMes, document.update.mICMPCode, document.update.mICMPType);

	//Protocol handled by enableMost
   	checkChoice(document.update.mProto, tcp, udp, document.update.mSourcePort, document.update.mCustSourcePort);
	checkChoice(document.update.mProto, tcp, udp, document.update.mTargetPort, document.update.mCustTargetPort);
	if(selectedChoice(document.update.mProto, tcp) || selectedChoice(document.update.mProto, udp))
	{
		checkChoice(document.update.mSourcePort, -1, 0, document.update.mCustSourcePort);
		checkChoice(document.update.mTargetPort, -1, 0, document.update.mCustTargetPort);
	}
}

// this is special version for test list page
function checkPortTest(icmpv6, icmp, tcp, udp)
{
	if( document.update.mProto.value == icmp  ||
		document.update.mProto.value == icmpv6 )
	{
		enable( document.update.mICMPMes );
		enable( document.update.mICMPCode );
		enable( document.update.mICMPType );
	}
	else
	{
		disable( document.update.mICMPMes );
		disable( document.update.mICMPCode );
		disable( document.update.mICMPType );
	}

	if(selectedChoice(document.update.mProto, tcp) || selectedChoice(document.update.mProto, udp))
	{
		document.update.mCustSourcePort.disabled = false;
		document.update.mCustTargetPort.disabled = false;
	}
	else
	{
		document.update.mCustSourcePort.disabled = true;
		document.update.mCustTargetPort.disabled = true;
	}
}


// this is a version that handles search page because it will break on the exception if use other one.
//logic is enable everything and disable as needed
function checkPort(icmpv6, icmp, tcp, udp)
{
    enableMost(icmpv6, icmp, tcp, udp);
	if(document.update.mProto.value == icmp || document.update.mProto.value == icmpv6 )
		checkICMPTypeCode();
	
	//Protocol handled by enableMost
   	checkChoice(document.update.mProto, tcp, udp, document.update.mSourcePort, document.update.mCustSourcePort);
	checkChoice(document.update.mProto, tcp, udp, document.update.mTargetPort, document.update.mCustTargetPort);
	if(selectedChoice(document.update.mProto, tcp) || selectedChoice(document.update.mProto, udp))
	{
		checkChoice(document.update.mSourcePort, -1, 0, document.update.mCustSourcePort);
		checkChoice(document.update.mTargetPort, -1, 0, document.update.mCustTargetPort);
	}
}

//set needed fields when Action = Except
function setForExcept()
{
	disableMost();
	hideMost();
	disable(document.update.mEvaluateReflect);
	
	if(document.update.mCustSourceAddr.value)
	{
		enable(document.update.mCustSourceAddr);
		disable(document.update.mCustSourcePort);
		disable(document.update.mCustTargetAddr);
		disable(document.update.mCustTargetPort);
	}		
	else if(document.update.mCustTargetAddr.value)
	{
		enable(document.update.mCustTargetAddr);
		disable(document.update.mCustSourcePort);
		disable(document.update.mCustSourceAddr);
		disable(document.update.mCustTargetPort);
	}
	else if(document.update.mCustSourcePort.value)
	{
		enable(document.update.mCustSourcePort);
		disable(document.update.mCustSourceAddr);
		disable(document.update.mCustTargetAddr);
		disable(document.update.mCustTargetPort);
	}
	else if(document.update.mCustTargetPort.value)
	{
		enable(document.update.mCustTargetPort);
		disable(document.update.mCustSourcePort);
		disable(document.update.mCustTargetAddr);
		disable(document.update.mCustSourceAddr);
	}
	else
	{
		enable(document.update.mCustSourceAddr);
		enable(document.update.mCustTargetAddr);
		enable(document.update.mCustSourcePort);
		enable(document.update.mCustTargetPort);
	}
}

//disable fields when evaluateReflect is checked
function setForEvalReflect()
{
	disable(document.update.mAccess);
	disable(document.update.mCustSourceAddr);
	disable(document.update.mCustSourcePort);
	disable(document.update.mCustTargetAddr);
	disable(document.update.mCustTargetPort);
	disableMost();
}

		
function setForComment()
{	
	disableMost();
	disable(document.update.mAccess);
	disable(document.update.mCustSourceAddr);
	disable(document.update.mCustSourcePort);
	disable(document.update.mCustTargetAddr);
	disable(document.update.mCustTargetPort);
	disable(document.update.mExpiration);
	disable(document.update.mEvaluateReflect);

	enable(document.update.mName);
}

//disable if sublist selected
function setForSublist()
{	
	disableMost();
	disable(document.update.mAccess);
	disable(document.update.mCustSourceAddr);
	disable(document.update.mCustSourcePort);
	disable(document.update.mCustTargetAddr);
	disable(document.update.mCustTargetPort);
	disable(document.update.mName);
	disable(document.update.mExpiration);
	disable(document.update.mEvaluateReflect);
	disable(document.update.mCommentOnly);
}

//disable field "toggle" if "selection" has the first field chosen
function checkChoice(selection, index, index2, toggle1, toggle2, toggle3)
{
	var set = true;
	if(index2)
	{
		if(!selectedChoice(selection, index) &&	!selectedChoice(selection, index2))
			set = true;
		else
			set = false;
	}
	else
	{
		if(!selectedChoice(selection, index))
			set = true;
		else
			set = false;
	}

	if(set)
	{
		toggle1.disabled=true;
		if(toggle2)
			toggle2.disabled=true;
		if(toggle3)
			toggle3.disabled=true;
	}
    else
	{
       	toggle1.disabled=false;
		// ALERT toggle1.focus();
		if(toggle2)
			toggle2.disabled=false;
		if(toggle3)
			toggle3.disabled=false;
    }
}

function disableMost(log)
{
	disable(document.update.mProto);
	disable(document.update.mSourceAddr);
	disable(document.update.mSourcePort);
	disable(document.update.mTargetAddr);
	disable(document.update.mTargetPort);
	disable(document.update.mICMPMes);	
	disable(document.update.mICMPType);
	disable(document.update.mICMPCode);
	disable(document.update.mTCPEstablished);
	disable(document.update.mReflect);
	if(!log)
		disable(document.update.mLog);		
}

function hideMost()
{
	hide(document.update.mAccess);
	hide(document.update.mProto);
	hide(document.update.mSourceAddr);
	hide(document.update.mSourcePort);
	hide(document.update.mTargetAddr);
	hide(document.update.mTargetPort);
	hide(document.update.mICMPMes);	
	hide(document.update.mICMPType);
	hide(document.update.mICMPCode);
	hide(document.update.mTCPEstablished);
	hide(document.update.mEvaluateReflect);
	hide(document.update.mReflect);
	hide(document.update.mLog);
}

//enable everything appropriately, while checking what should be enabled
function enableMost(icmpv6, icmp, tcp, udp)
{
	var elem = document.update.mAccess;
	if(elem)
		enable(elem);
	enable(document.update.mProto);
	enable(document.update.mSourceAddr);

checkChoice(document.update.mSourceAddr, -1,0, document.update.mCustSourceAddr);
	enable(document.update.mSourcePort);
	checkChoice(document.update.mSourcePort, -1,0, document.update.mCustSourcePort);
	enable(document.update.mTargetAddr);
	checkChoice(document.update.mTargetAddr, -1,0, document.update.mCustTargetAddr);
	enable(document.update.mTargetPort);
	checkChoice(document.update.mTargetPort, -1,0, document.update.mCustTargetPort);

	checkChoice(document.update.mProto, icmp,icmpv6, 
		document.update.mICMPMes, document.update.mICMPCode, document.update.mICMPType);

}

function enableRest(icmp,tcp,udp)
{
	// these are not on the search page.
	checkChoice(document.update.mProto, tcp,0, document.update.mTCPEstablished);
	enable(document.update.mReflect);
	enable(document.update.mEvaluateReflect);
	enable(document.update.mLog);
	enable(document.update.mName);
	enable(document.update.mExpiration);
	enable(document.update.mCommentOnly);
}

function disable(selection)
{
	selection.disabled = true;
}
function hide(selection)
{
	selection.style.display = "none";
}
function show(selection)
{
	selection.style.display = "inline";
}
function enable(selection)
{
	selection.disabled = false;
}

//check "selection" to see if first choice is selected
function selectedChoice(selection, index) 
{
    return selection.value==index; 
}

function globalnetsChange()
{
	var w = document.update.globalnets.selectedIndex;
	var nameStr = document.update.globalnets.options[w].text;
	if( nameStr != '' )
		document.update.mName.value = nameStr;
}

function howManyChange(cfgitem)
{
	var perStr = document.pagerform.howmany.value;
	// Get query fields, replace per with perStr and reload
	var newsearch = document.location.search;
	newsearch = ChangeGetParam(newsearch, 'action','');
	newsearch = ChangeGetParam(newsearch, 'offset','');
	newsearch = ChangeGetParam(newsearch, 'perpage',perStr);
	window.location.search= newsearch;
}

//if Action = Except, allow only one input field to have text at a time
function toggleInputFields(field, except, ports)
{
	if(selectedChoice(document.update.mAccess, except))
		if(field.value != "")
		{
			if(field != document.update.mCustSourceAddr) 
				disable(document.update.mCustSourceAddr);
			if(field != document.update.mCustSourcePort) 
				disable(document.update.mCustSourcePort);
			if(field != document.update.mCustTargetAddr) 
				disable(document.update.mCustTargetAddr);
			if(field != document.update.mCustTargetPort) 
				disable(document.update.mCustTargetPort);
		}
		else
		{
			enable(document.update.mCustSourceAddr);
			if(ports)
				enable(document.update.mCustSourcePort);
			enable(document.update.mCustTargetAddr);
			if(ports)
				enable(document.update.mCustTargetPort);
		}
}



function toggleContext()
{
	// contextform, contextlabel
	var elem = document.getElementById('contextform');
	if( elem != null )
	{
		if( elem.style.display == "none" )
			elem.style.display = "inline";
		else
			hide(elem);
	}
}

function changecss(theClass,element,value) 
{
	var cssRules;
	var added = false;
	for (var S = 0; S < document.styleSheets.length; S++)
	{
		if (document.styleSheets[S]['rules']) 
		{
			cssRules = 'rules';
		} 
		else if (document.styleSheets[S]['cssRules']) 
		{
			cssRules = 'cssRules';
		} 
		else 
		{
    		//no rules found... browser unknown
		}
						 	 	     	  	 	  	 	  	 	  
														
		for (var R = 0; R < document.styleSheets[S][cssRules].length; R++) 
		{
			if (document.styleSheets[S][cssRules][R].selectorText == theClass) 
			{
				if(document.styleSheets[S][cssRules][R].style[element])
				{
					document.styleSheets[S][cssRules][R].style[element] = value;
					added=true;
					break;
				}
			}
		}
		if(!added)
		{
			if(document.styleSheets[S].insertRule)
			{
				document.styleSheets[S].insertRule(theClass+' { '+element+': '+value+'; }',document.styleSheets[S][cssRules].length);
			} 
			else if (document.styleSheets[S].addRule) 
			{
				document.styleSheets[S].addRule(theClass,element+': '+value+';');
			}
		}
	}
}
